/*
** bios-awdmedal.c
*/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include <main.h>

#define OFF_PWDSUPER_DIGEST	0x5a

/*
** Check validity of pwds returned by <get_next_pwd>
*/
void		awdmedal_pwd_check(
	int	fd,
	bios_t	*b,
       	char	*(*get_next_pwd)(bios_t *b, char *pwd),
       	void	(*notify_valid_pwd)(const char *pwd))
{
    unsigned char	dig_buf[2];
    unsigned		dig_val;
    char		*pwd;

    read_nbytes_at(fd, dig_buf, OFF_PWDSUPER_DIGEST, sizeof (dig_buf));
    dig_val = (dig_buf[0] << 0) + (dig_buf[1] << 8);
    pwd = 0;
    while ((pwd = (*get_next_pwd)(b, pwd)))
	if (dig_val == generic_16bits_digest(b, (unsigned char *)pwd))
	    (*notify_valid_pwd)(pwd);
}
