/*
** bios-awdmod.c
*/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include <main.h>

#define OFF_PWDSUPER_ENALBE	0x03
#define BIT_PWDSUPER_ENABLE	1
#define OFF_PWDSUPER_DIGEST	0x0e

/*
** Check validity of pwds returned by <get_next_pwd>
*/
void		awdmod_pwd_check(
	int	fd,
	bios_t	*b,
       	char	*(*get_next_pwd)(bios_t *b, char *pwd),
       	void	(*notify_valid_pwd)(const char *pwd))
{
    unsigned char	dig_buf[2];
    unsigned		dig_val;
    char		*pwd;
    int			i;

    read_nbytes_at(fd, dig_buf, OFF_PWDSUPER_DIGEST, sizeof (dig_buf));
    dig_val = (dig_buf[0] << 0) + (dig_buf[1] << 8);
    /*
    fprintf(stderr, "Bios digest value: %u\n", dig_val);
    */
    i = 0;
    pwd = 0;
    while ((pwd = (*get_next_pwd)(b, pwd)))
      {
	/*
	if (!(i++ % 1000000))
	    fprintf(stderr, "\rdigest(%s)=%u", pwd,
		    generic_16bits_digest(b, (unsigned char *)pwd));
	*/
	if (dig_val == generic_16bits_digest(b, (unsigned char *)pwd))
	    (*notify_valid_pwd)(pwd);
      }
}

/*
** Enable/disable the bios password
*/
void		awdmod_pwd_set_onoff(int fd, bios_t *b, int onoff)
{
  unsigned char	c;

  read_nbytes_at(fd, &c, OFF_PWDSUPER_ENALBE, 1);
  if (onoff)
      c |= (1 << BIT_PWDSUPER_ENABLE);
  else
      c &= ~(1 << BIT_PWDSUPER_ENABLE);
  write_nbytes_at(fd, &c, OFF_PWDSUPER_ENALBE, 1);
  (void)b; /* avoid the "unused parameter" warning */
}
